"Apache Maven retrieves all components from the Central Repository by default. Starting with Maven 3.2.3 the default access is via HTTPS and no further configuration is required.
Up to Maven version 3.2.2, no further configuration is required for access via HTTP, though this is no longer recommended given the availability of the HTTPS transport."[Central Repo].

So any maven version up to 3.2.2 uses HTTP by default to fetch package from central repository.

Follwing is the discussion on Stack Overflow on potential exploit of maven:

# DNS cache poisoning #

The DNS data you use to get to the standard repositories could be poisoned, causing Maven to download artifacts from a different repository.

# Non-standard repositories #

Any repository you add to your Maven configuration could provide artifacts that include malicious code. Prevent this by using only those 3rd party repositories that you trust.

# Repository poisoning #

Based on Maven's [Guide to uploading artifacts to the Central Repository], it looks like the central Maven repository publishes artifacts from approved repository hosts, so security of artifacts depends on the host. I don't know specifics about the process of becoming an approved repository host, but with so few listed it's probably onerous.

In addition, the central repo requires PGP signatures for all deployments, so unless a malicious user gains access to the private key for a project, I don't think this is possible.

# Artifact modification during transmission (man in the middle) #

Maven does automatic checksum verification for all artifacts, so the attacker would have to modify the artifact and the accompanying checksums to inject malicious code. I don't know if you could prevent it completely, but to make sure you're paying attention to checksums, make sure your checksum policy isn't set to ignore. See the [settings doc].

[Guide to uploading artifacts to the Central Repository]: http://maven.apache.org/guides/mini/guide-central-repository-upload.html
[setting doc]: http://maven.apache.org/settings.html
[Central Repo]: http://central.sonatype.org/pages/consumers.html#apache-maven

